routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\FacturaController;
use App\Http\Controllers\ClienteController;
use App\Http\Controllers\ProductoController;
use App\Http\Controllers\TipoFacturacionController;
use Illuminate\Support\Facades\Auth;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
});

//Auth::routes();

//Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

Route::middleware(['auth:sanctum', 'verified'])->get('/home', function () {
    return view('home');
})->name('home');
Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

//se define las rutas para el controlador de Facturas:
Route::resource('facturas', FacturaController::class);
Route::resource('clientes', ClienteController::class);
Route::resource('productos', ProductoController::class);
Route::resource('tipo_facturacion', TipoFacturacionController::class);

Route::get('factura/precio', [FacturaController::class, 'getPrecioProducto'])->name('factura.precio');


//se definen las rutas para el controlador de clientes
Route::get('/clientes', [ClienteController::class, 'index'])->name('clientes.index');
Route::get('/clientes/create', [ClienteController::class, 'create'])->name('clientes.create');
Route::post('/clientes', [ClienteController::class, 'store'])->name('clientes.store');
Route::get('/clientes/{id}', [ClienteController::class, 'show'])->name('clientes.show');
Route::get('/clientes/{id}/edit', [ClienteController::class, 'edit'])->name('clientes.edit');
Route::put('/clientes/{id}', [ClienteController::class, 'update'])->name('clientes.update');
Route::delete('/clientes/{id}', [ClienteController::class, 'destroy'])->name('clientes.destroy');

//se definen las rutas para el controlador de productos
/*
Route::get('/productos', [ProductoController::class, 'index'])->name('productos.index');
Route::get('/productos/crear', [ProductoController::class, 'create'])->name('productos.create');
Route::post('/productos', [ProductoController::class, 'store'])->name('productos.store');
Route::get('/productos/{id}/editar', [ProductoController::class, 'edit'])->name('productos.edit');
Route::put('/productos/{id}', [ProductoController::class, 'update'])->name('productos.update');
Route::delete('/productos/{id}', [ProductoController::class, 'destroy'])->name('productos.destroy');
*/

app/Models/TipoFacturacion.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class TipoFacturacion extends Model
{
    use HasFactory;

    public $timestamps = false;

    protected $table = 'tipo_facturacion';

    protected $fillable = [
        'descripcion',
    ];

    public function facturas()
    {
        return $this->hasMany(Factura::class);
    }
}

app/Http/Controllers/TipoFacturacionController.php
<?php
namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\TipoFacturacion;

class TipoFacturacionController extends Controller
{
    public function index()
    {
        $tipos_facturacion = TipoFacturacion::all();
        return view('tipo_facturacion.index', compact('tipos_facturacion'));
    }

    public function create()
    {
        return view('tipo_facturacion.create');
    }

    public function store(Request $request)
    {
        $request->validate([
            'descripcion' => 'required|string|max:100',
        ]);

        TipoFacturacion::create($request->all());
        return redirect()->route('tipo_facturacion.index')->with('success', 'El tipo de facturación ha sido creado exitosamente.');
    }

    public function edit($id)
    {
        $tipo_facturacion = TipoFacturacion::find($id);
        return view('tipo_facturacion.edit', compact('tipo_facturacion'));
    }

    public function update(Request $request, $id)
    {
        $request->validate([
            'descripcion' => 'required|string|max:100',
        ]);

        $tipo_facturacion = TipoFacturacion::find($id);
        $tipo_facturacion->update($request->all());
        return redirect()->route('tipo_facturacion.index')->with('success', 'El tipo de facturación ha sido actualizado exitosamente.');
    }

    public function destroy($id)
    {
        $tipo_facturacion = TipoFacturacion::find($id);
        $tipo_facturacion->delete();
        return redirect()->route('tipo_facturacion.index')->with('success', 'El tipo de facturación ha sido eliminado exitosamente.');
    }
}

resources/views/tipo_facturacion/create.blade.php
@extends('adminlte::page')

@section('title', 'Tipo Facturacion')

@section('content_header')
    <h1>Nuevo Tipo Facturación</h1>
@stop

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card">
                    

                    <div class="card-body">
                        <form method="POST" action="{{ route('tipo_facturacion.store') }}">
                            @csrf

                            <div class="form-group row">
                                <label for="descripcion"
                                    class="col-md-4 col-form-label text-md-right">{{ __('Descripción') }}</label>

                                <div class="col-md-6">
                                    <input id="descripcion" type="text"
                                        class="form-control @error('descripcion') is-invalid @enderror" name="descripcion"
                                        value="{{ old('descripcion') }}" required autocomplete="descripcion" autofocus>

                                    @error('descripcion')
                                        <span class="invalid-feedback" role="alert">
                                            <strong>{{ $message }}</strong>
                                        </span>
                                    @enderror
                                </div>
                            </div>

                            <div class="form-group row mb-0">
                                <div class="col-md-6 offset-md-4">
                                    <button type="submit" class="btn btn-primary">
                                        {{ __('Crear') }}
                                    </button>
                                    <a href="{{ route('tipo_facturacion.index') }}" class="btn btn-secondary">
                                        {{ __('Cancelar') }}
                                    </a>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>

@stop

resources/views/tipo_facturacion/edit.blade.php
@extends('adminlte::page')

@section('title', 'Tipo Facturacion')

@section('content_header')
    <h1>Editar Tipo de Facturación</h1>
@stop

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card">
                    
                    <div class="card-body">
                        <form method="POST" action="{{ route('tipo_facturacion.update', $tipo_facturacion->id) }}">
                            @csrf
                            @method('PUT')

                            <div class="form-group row">
                                <label for="descripcion"
                                    class="col-md-4 col-form-label text-md-right">{{ __('Descripción') }}</label>

                                <div class="col-md-6">
                                    <input id="descripcion" type="text"
                                        class="form-control @error('descripcion') is-invalid @enderror" name="descripcion"
                                        value="{{ old('descripcion', $tipo_facturacion->descripcion) }}" required
                                        autocomplete="descripcion" autofocus>

                                    @error('descripcion')
                                        <span class="invalid-feedback" role="alert">
                                            <strong>{{ $message }}</strong>
                                        </span>
                                    @enderror
                                </div>
                            </div>

                            <div class="form-group row mb-0">
                                <div class="col-md-6 offset-md-4">
                                    <button type="submit" class="btn btn-primary">
                                        {{ __('Guardar Cambios') }}
                                    </button>
                                    <a href="{{ route('tipo_facturacion.index') }}" class="btn btn-secondary">
                                        {{ __('Cancelar') }}
                                    </a>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@stop

resources/views/tipo_facturacion/index.blade.php
@extends('adminlte::page')

@section('title', 'Tipo Facturacion')

@section('content_header')
    <h1>Lista Tipo Facturación</h1>
@stop

@section('content')
    <div class="container">
        <p>
            <a href="{{ route('tipo_facturacion.create') }}" class="btn btn-success">
                Nuevo Tipo
            </a>
        </p>
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                    

                    <div class="card-body">
                        @if (session('success'))
                            <div class="alert alert-success">
                                {{ session('success') }}
                            </div>
                        @endif

                        <table class="table">
                            <thead>
                                <tr>
                                    <th>ID</th>
                                    <th>Descripción</th>
                                    <th>Fecha de creación</th>
                                    <th>Acciones</th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach ($tipos_facturacion as $tipoFacturacion)
                                    <tr>
                                        <td>{{ $tipoFacturacion->id }}</td>
                                        <td>{{ $tipoFacturacion->descripcion }}</td>
                                        <td>{{ $tipoFacturacion->fecha_creacion }}</td>
                                        <td>
                                            <a href="{{ route('tipo_facturacion.edit', $tipoFacturacion->id) }}"
                                                class="btn btn-sm btn-warning">Editar</a>

                                            <form action="{{ route('tipo_facturacion.destroy', $tipoFacturacion->id) }}"
                                                method="POST" style="display: inline-block;">
                                                @csrf
                                                @method('DELETE')
                                                <button type="submit" class="btn btn-sm btn-danger"
                                                    onclick="return confirm('¿Estás seguro de que deseas eliminar este tipo de facturación?')">Eliminar</button>
                                            </form>
                                        </td>
                                    </tr>
                                @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
@stop